c     Dynamic height caclulation
      parameter(km=1000)
      
      character*100 path
      real*8 z(km),T(km),S(km),rho(km),pres(km),
     &rhoo(km),rho1,delta(km),D(km)
      real*8 T0,S0,grav
      
      grav=9.806e0
      T0=0.0;S0=35.0

      path='E:\My Documents\Ebook_Oceanography\fortran_codes\'
      open(1,file=trim(path)//'input_example_dynamic_height.dat')
      kmax=98
      
      do k=1,kmax
      read(1,*)z(k),S(k),T(k)
      enddo
      close(1)
      do k=1,kmax
      call density(T(k),S(k),z(k),rho1)
      rho(k)=1000.0+rho1
      pres(k)=rho(k)*grav*z(k) !pressure in Pascal
      call density(T0,S0,z(k),rho1)
      rhoo(k)=1000.0+rho1
      delta(k)=1/rho(k)-1/rhoo(k)
      enddo
      
      
      D(1)=0.0
      do k=2,kmax
      
      D(k)=D(k-1)+0.5*(delta(k-1)+delta(k))*(pres(k)-pres(k-1))
      
      enddo
      
      open(2,file=trim(path)//'output_dynamic_height.dat')
      write(2,'(3(x,a6),3(x,a12))')'z[m]','S','T[oC]','rho[kg/m3]',
     &'p[Pa]','D[m2/s2]'
      do k=1,kmax
      write(2,22)z(k),S(k),T(k),rho(k),pres(k),D(k)
      enddo
22    format(6(x,f18.10))      
  

      
      
      stop
      end
      
      
      subroutine density(T,S,z,rho)
      
      real*8 T,S,z,rho
      real*8 t2,t3,t4,grav,rhoref,cr
      
      grav=9.806e0
      rhoref=1025.0
      t2=T*T
      t3=t2*T
      t4=t3*T
      
      p=grav*rhoref*z*1.e-5

            rho=-0.157406e0+6.793952e-2*T
     $            -9.095290e-3*t2+1.001685e-4*t3
     $            -1.120083e-6*t4+6.536332e-9*t4*T

            rho=rho+(0.824493e0-4.0899e-3*T
     $            +7.6438e-5*t2-8.2467e-7*t3
     $            +5.3875e-9*t4)*S
     $            +(-5.72466e-3+1.0227e-4*T
     $            -1.6546e-6*t2)*abs(S)**1.5
     $            +4.8314e-4*S*S

            cr=1449.1e0+.0821e0*p+4.55e0*T-.045e0*t2
     $          +1.34e0*(S-35.e0)
            rho=rho+1.e5*p/(cr*cr)*(1.e0-2.e0*p/(cr*cr))
            
      return
      end